#pragma once

#include <ControlledMotor.h>
#include <Motor.h>
#include <Thing.h>
#include <Vector2.h>
#include <Vector3.h>
#include "Sensor.h"

class Placement {
 public:
  Placement();
  Placement(Vector2 direction, Sensor* sensor);

  Placement(Vector3 position, Sensor* sensor);
  Placement(Vector3 position, Motor* motor);
  Placement(Vector3 position, ControlledMotor* motor);
  Placement(Thing* thing, Vector3 position);

  Placement* parent = nullptr;
  Placement** children = nullptr;
  unsigned int childCount = 0;

  Vector3 position;
  Vector2 direction;
  Thing* thing;
};
